<template>
  <v-dialog v-model="dialogAirport" @click:outside="close" max-width="50%">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-6"></v-divider>

      <AdminAirportsAirportForm :airport="airport" />

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" class="text-uppercase" data-cy="AirportFormCancelBtn" @click="close()">
          Annuler
        </v-btn>
        <v-btn variant="outlined" rounded size="large" data-cy="AirportFormOkBtn" class="text-uppercase inverted" :disabled="!meta.valid"
          :loading="loading" @click="confirm()">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">

import { Airport } from "~/dto/airport.dto";

const dialogAirport = defineModel<boolean>()

const props = defineProps<{
  airport: Airport
}>()

const emit = defineEmits(['close', 'confirm'])

const { validate, meta } = useForm({
  initialValues: props.airport
})

const dialogTitle = ref(props.airport.id ? `Édition d'un aéroport` : `Création d'un aéroport`);
const loading = ref(false);
const form: Ref<any> = ref(null);

const close = () => {
  emit('close');
};

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm');
  loading.value = true;
};

</script>
